/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// WriterTarget the model 'WriterTarget'
type WriterTarget string

// List of WriterTarget
const (
	WriterTargetTx WriterTarget = "tx"
	WriterTargetContact WriterTarget = "contact"
)

// All allowed values of WriterTarget enum
var AllowedWriterTargetEnumValues = []WriterTarget{
	"tx",
	"contact",
}

func (v *WriterTarget) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := WriterTarget(value)
	for _, existing := range AllowedWriterTargetEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid WriterTarget", value)
}

// NewWriterTargetFromValue returns a pointer to a valid WriterTarget
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewWriterTargetFromValue(v string) (*WriterTarget, error) {
	ev := WriterTarget(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for WriterTarget: valid values are %v", v, AllowedWriterTargetEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v WriterTarget) IsValid() bool {
	for _, existing := range AllowedWriterTargetEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to WriterTarget value
func (v WriterTarget) Ptr() *WriterTarget {
	return &v
}

type NullableWriterTarget struct {
	value *WriterTarget
	isSet bool
}

func (v NullableWriterTarget) Get() *WriterTarget {
	return v.value
}

func (v *NullableWriterTarget) Set(val *WriterTarget) {
	v.value = val
	v.isSet = true
}

func (v NullableWriterTarget) IsSet() bool {
	return v.isSet
}

func (v *NullableWriterTarget) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWriterTarget(val *WriterTarget) *NullableWriterTarget {
	return &NullableWriterTarget{value: val, isSet: true}
}

func (v NullableWriterTarget) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWriterTarget) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

